﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.2.9 - Core
-- Meranannon - Insane - Vol'jin (EU)
-- rev 2
----------------------------------------------------------------------------------------------------

-- namespace
local DF = DF_namespace
local oldTalent = nil
local inspectTalent = true
local DFfirstoptions=true

-- cadre qui recoit event
DFeventFrame = CreateFrame("FRAME","DFeventFrame",UIParent)

---- events et scripts
function DF:setUp()

		-- events
	DFeventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	DFeventFrame:SetScript("OnEvent", DF.OnEvent)
	
end

-- init frames
function DF:init_frames()
	-- création objets ou màj
	DF:init_anchor_frame()
	DF:init_powerbar_frame()
	DF:init_healthbar_frame()
	DF:init_manabar_frame()
	DF:init_eclipsebar_frame()
	DF:init_targetbar_frame()
	DF:init_threatbar_frame()
	DF:init_spells_list()
	DF:init_icons_frame()
	DF:init_timerbars_frame()
	DF:init_combo_frame()
	DF:init_arrows_frame()
	DF:init_alert_frame()
	DF:init_cooldown_frame()	
	DF:init_blood_frame()
	DF:init_infos_frame()
	DF:init_portrait_frame()
	DF:init_gps_frame()
	DF:init_castbar_frame()
	DF:init_ooc_frame()
	--DF:init_dottimer_frame()

end

-- events Handlers
function DF:OnEvent(eventArg,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18)

	if(eventArg == "PLAYER_ENTERING_WORLD") then
		
		DF.playerId = UnitGUID("player")
		DF.playerLevel = UnitLevel("player")
		
		DF.screenHeight = GetScreenHeight()
		DF.screenWidth = GetScreenWidth()
		
		DF.uiAlwaysShow=true

		if (DFfirstoptions==true) then
			-- ligne de comm
			SLASH_DroodFocusSL1 = "/df";
			SLASH_DroodFocusSL2 = "/droodfocus";
			SlashCmdList["DroodFocusSL"] = DroodFocusSL_SlashCmd;
	
			if not DF_config then
				DF_config = DF:deepcopy(DF_pred_configs[1])
				DEFAULT_CHAT_FRAME:AddMessage(DF.locale["first"])
			end
	
			if not DF_saved_configs then
				DF_saved_configs = {}
			end
	
			if not DF_sharemedia then
				DF_sharemedia = {}
			end
	
			if not DF_talents then
				DF_talents = {}
			end
	
			if not DF_animaticsList then
				DF_animaticsList={}
			end

			if not DF_cdsList then
				DF_cdsList={}
			end
	
			DF:completeTable(DF_config,DF_pred_configs[1],false)
			DF:updateTable()
	
			_,DF.playerClass=UnitClass("player")
			DF:form_initStanceList()
			DF:libs_registerUsersFiles()		
			
			if not DF_config.MiniMapAngle then
				DF_config.MiniMapAngle=0
			end
		
			DF:init_frames()
			DF:toggle_toggle()
	
			DF:DF_MinimapLoad()
			DF_MinimapToggle()
			
			DF:spellslist_initTable()
			DF:cooldown_initTable()
			DF:options_createpanels()	
				
			DFeventFrame:SetScript("OnUpdate", function(self,elapsed)
				DF:OnUpdate(elapsed)
			end)			

			DFeventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			DFeventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
			DFeventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
			DFeventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")		
			DFeventFrame:RegisterEvent("ZONE_CHANGED")		
			DFeventFrame:RegisterEvent("SPELL_AURA_APPLIED")		
			DFeventFrame:RegisterEvent("SPELL_PERIODIC_DAMAGE")			
		
			-- reminder
			if (DF_config.configversion~=DROODFOCUS_CONFIGVERSION and DF.automaticReminder==true) then
				DF:options_show("DroodFocusMessage",nil)
			end
			
			-- màj numéro de version de la config active
			DF_config.configversion=DROODFOCUS_CONFIGVERSION

			-- bienvenue
			DEFAULT_CHAT_FRAME:AddMessage(DF.locale["welcome"])

		end
		
		DFfirstoptions=false

	elseif(eventArg == "ZONE_CHANGED") then

		SetMapToCurrentZone()

	elseif(eventArg == "PLAYER_TARGET_CHANGED") then

		DF.haveTarget=UnitGUID("target")
		DF:targetbar_clearT2D()
		DF:healthbar_clearT2D()
		
	elseif(eventArg == "PLAYER_REGEN_ENABLED") then
		
		DF.menace=0
		DF:spells_clearPA()
		DF:dottimer_clearDots()
		DF:combat_set_state(false)
		DF:sound_roar()
		DF:toggle_toggle()
		DF:targetbar_clearT2D()
		DF:healthbar_clearT2D()
						
	elseif(eventArg == "PLAYER_REGEN_DISABLED") then
		
		DF:combat_set_state(true)
		DF:spells_desactivate()
		DF:toggle_toggle()
			
	elseif(eventArg == "COMBAT_LOG_EVENT_UNFILTERED") then	

   	if (arg2=="SWING_DAMAGE") then

			if (arg3==DF.playerId and arg15==1) then
				
				DF:blood_activate(0.75)
			 	
			end
		elseif (arg2=="SPELL_DAMAGE") then

			if (arg3==DF.playerId and arg18==1) then
				
	 			DF:sound_set_state(true)
				DF:blood_activate(1)
			 	
			end
			
		elseif (arg2=="SPELL_CAST_FAILED") then
		
			if (arg3==DF.playerId) then
	
				if (arg12==SPELL_FAILED_OUT_OF_RANGE) then
					DF:alert_activate("2")
					
				elseif (arg12==SPELL_FAILED_NOT_BEHIND) then
					DF:alert_activate("1")
					
				end
			end

		elseif(arg2 == "SPELL_AURA_APPLIED") then
	
				if arg3==DF.playerId then
					DF:dottimer_addDots(arg1,arg6,arg9,true,arg12)
				end	
				
				if arg6==DF.playerId then
				
					if (arg12=="DEBUFF" and DF_config.alert.showDebuff) then
		
						-- le joueur viens de subir un debuff, affiche l'icone dans le système d'alert
						local _, _, imgDebuff, _, _, _, _, _, _ = GetSpellInfo(arg9);
						if imgDebuff then
							DF:alert_activate(imgDebuff,true)
						end
						
					elseif (arg12=="BUFF" and DF_config.alert.showBuff) then
		
						-- le joueur viens de gagner un buff, affiche l'icone dans le système d'alert
						local _, _, imgDebuff, _, _, _, _, _, _ = GetSpellInfo(arg9);
						if imgDebuff then
							DF:alert_activate(imgDebuff,true)
						end					
						
					end		
							
				end
	
		elseif((arg2 == "SPELL_PERIODIC_DAMAGE" or arg2 == "SPELL_PERIODIC_HEAL") and arg3==DF.playerId) then
	
				DF:dottimer_addDots(arg1,arg6,arg9,false,arg12)

		end		

	end

end

function DF:isInRaid()
	return GetNumRaidMembers()
end

-- OnUpdate
function DF:OnUpdate(elapsed)

	DF.currentTime = GetTime()

	DF:toggle_toggle()

	DF:spells_update(elapsed)

	DF:icons_update(elapsed)
	DF:timerbars_update(elapsed)
	DF:ooc_update(elapsed)
	DF:combo_update(elapsed)
	DF:dottimer_update(elapsed)
	DF:arrows_update(elapsed)
	DF:alert_update(elapsed)
	DF:cooldown_update(elapsed)
	DF:infos_update(elapsed)
	DF:portrait_update(elapsed)
	DF:gps_update(elapsed)
	DF:castbar_update(elapsed)
	DF:powerbar_update(elapsed)
	DF:healthbar_update(elapsed)
	DF:manabar_update(elapsed)	
	DF:eclipsebar_update(elapsed)	
	DF:targetbar_update(elapsed)
	DF:threatbar_update(elapsed)
	DF:blood_update(elapsed)
	DF:practice_scanner(elapsed)
	
end

function DF:toogle_lock()

	if DF.lock then
		itsok=false
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["locked"])
	else
		itsok=true
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["unlocked"])
	end
	
	DF.configmode = itsok
	
	DF:toggle_toggle()
	
	DF:anchor_toogle_lock(itsok)
	DF:powerbar_toogle_lock(itsok)
	DF:healthbar_toogle_lock(itsok)
	DF:manabar_toogle_lock(itsok)
	DF:eclipsebar_toogle_lock(itsok)
	DF:targetbar_toogle_lock(itsok)
	DF:threatbar_toogle_lock(itsok)
	DF:combo_toogle_lock(itsok)
	DF:icons_toogle_lock(itsok)
	DF:timerbars_toogle_lock(itsok)
	DF:alert_toogle_lock(itsok)
	DF:gps_toogle_lock(itsok)
	DF:castbar_toogle_lock(itsok)
	DF:cooldown_toogle_lock(itsok)
	DF:infos_toogle_lock(itsok)
	DF:portrait_toogle_lock(itsok)
	DF:ooc_toogle_lock(itsok)
	
	DF:blood_activate(0.5)
	DF:blood_activate(1)
	DF:blood_activate(0.5)
	DF:blood_activate(1)
	
end

-- gestion ligne de commande
function DroodFocusSL_SlashCmd(arg)

	local conf=0
	
	-- parse
	if (arg==nil) then
		
		arg="";
		
	else
		
		listargs = DF:explode ( " ", string.lower(arg) );
		
		arg = string.lower(listargs[1]);

		if (listargs[2]) then
			arg2 = listargs[2];
		else
			arg2="";
		end
		if (listargs[3]) then
			arg3 = listargs[3];
		else
			arg3="";
		end	
			
	end

	-- action
	if (arg=="configmode") then
		DF:toogle_configmode()
		
	elseif (arg=="options") then	
		
		DF:options_show("DFOPTIONSelement")

	elseif (arg=="reset") then	
		
		DF:config_Reset()

	elseif (arg=="buff") then	

		DF:ShowID("buff")
		
	elseif (arg=="debuff") then	

		DF:ShowID("debuff")		
		
	elseif (arg=="spells") then
	
		DF:show_spellslist()
	
	elseif (arg=="news") then
	
		DF:options_show("DroodFocusMessage",nil)
			
	elseif (arg=="practice") then
	
		if DF.practiceNotRunning==false then
			DF.practiceNotRunning=true
		else
			DF.practiceNotRunning=false
		end
		DF:practice_toggle()

	elseif (arg=="center") then
	
		DF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

		DF.baseanchor.base:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config["anchor0"].positionx, DF_config["anchor0"].positiony)
	
	elseif (arg=="refs") then
	
		DF:luaCode_showRefs()
		
	else
		
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["commands"])
		
	end
	
end

function DF:toogle_configmode()
	
	if DF.lock then	DF.lock = false	else DF.lock = true	end
	DF:toogle_lock()
	
end

function DF:ShowID(ftype)

	DF:debugLine("Begin list of ",ftype)		

	local index=1
	while true do 

		if ftype=="buff" then
			
			name, _, _, _, debuffType, _, _, unitCaster, _, _, spellId = UnitAura("player", index, "HELPFUL") 
		
		elseif ftype=="debuff" then
			
			name, _, _, _, debuffType, _, _, unitCaster, _, _, spellId = UnitAura("playertarget", index, "HARMFUL") 
		
		else
		
			name=nil
		
		end

		if not name then break end

		DF:debugLine(ftype.." "..tostring(index)..": "..tostring(name),spellId)		
		
		index=index+1
		
	end
	DF:debugLine("End list of ",ftype)
end

-- démarrage
DF:setUp()